/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.validator.Field;
import org.apache.commons.validator.GenericValidator;
import org.apache.commons.validator.ValidatorAction;
import org.apache.commons.validator.util.ValidatorUtils;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.validator.Resources;

/**
 * TODO documentation
 * 
 * @author rlogiacco@users.sourceforge.net
 * @stereotype static
 */
public class Validator {

	/**
	 * TODO documentation
	 * 
	 * @param bean
	 * @param action
	 * @param field
	 * @param errors
	 * @param request
	 * @return
	 */
	public static boolean confirmed(Object bean, ValidatorAction action, Field field, ActionErrors errors, HttpServletRequest request) {
		String value = ValidatorUtils.getValueAsString(bean, field.getProperty());
		String confirm = ValidatorUtils.getValueAsString(bean, field.getVarValue("confirm"));
		if (!GenericValidator.isBlankOrNull(value)) {
			try {
				if (!value.equals(confirm)) {
					errors.add(field.getKey(), Resources.getActionMessage(request, action, field));
					return false;
				}
			} catch (Exception e) {
				errors.add(field.getKey(), Resources.getActionMessage(request, action, field));
				return false;
			}
		}
		return true;
	}

	/**
	 * TODO documentation
	 * 
	 * @param bean
	 * @param action
	 * @param field
	 * @param errors
	 * @param request
	 * @return
	 */
	public static boolean before(Object bean, ValidatorAction action, Field field, ActionErrors errors, HttpServletRequest request) {
		return true;
	}

	/**
	 * TODO documentation
	 * 
	 * @param bean
	 * @param action
	 * @param field
	 * @param errors
	 * @param request
	 * @return
	 */
	public static boolean after(Object bean, ValidatorAction action, Field field, ActionErrors errors, HttpServletRequest request) {
		return true;
	}
}