/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
package net.smartlab.web.bean;

import java.util.List;
import java.util.Locale;

/**
 * TODO documentation
 * 
 * @author rlogiacco@users.sourceforge.net
 */
public class BooleanArrayConverter extends ArrayConverter {

	private static final boolean[] model = new boolean[0];


	/**
	 * @see net.smartlab.web.bean.Converter#convert(java.lang.Class,
	 *      java.lang.Object, java.util.Locale)
	 */
	public Object convert(Class to, Object value, Locale locale) throws ConversionException {
		// Deal with the no-conversion-needed case
		if (model.getClass() == value.getClass()) {
			return (value);
		}
		// Deal with input value as a String array
		if (ArrayConverter.model.getClass() == value.getClass()) {
			try {
				String values[] = (String[])value;
				boolean[] results = new boolean[values.length];
				for (int i = 0; i < values.length; i++) {
					if (values[i].toString().equalsIgnoreCase("on") || values[i].toString().equalsIgnoreCase("y")
							|| values[i].toString().equalsIgnoreCase("yes")
							|| values[i].toString().equalsIgnoreCase("1")
							|| values[i].toString().equalsIgnoreCase("true")) {
						results[i] = true;
					} else if (values[i].toString().equalsIgnoreCase("off")
							|| values[i].toString().equalsIgnoreCase("n")
							|| values[i].toString().equalsIgnoreCase("no")
							|| values[i].toString().equalsIgnoreCase("0")
							|| values[i].toString().equalsIgnoreCase("false")) {
						results[i] = false;
					} else {
						throw new ConversionException();
					}
				}
				return (results);
			} catch (Exception e) {
				throw new ConversionException(value.toString(), e);
			}
		}
		// Parse the input value as a String into elements
		// and convert to the appropriate type
		try {
			List list = parseElements(value.toString());
			boolean[] results = new boolean[list.size()];
			for (int i = 0; i < results.length; i++) {
				if (((String)list.get(i)).equalsIgnoreCase("on") || ((String)list.get(i)).equalsIgnoreCase("y")
						|| ((String)list.get(i)).equalsIgnoreCase("yes") || ((String)list.get(i)).equalsIgnoreCase("1")
						|| ((String)list.get(i)).equalsIgnoreCase("true")) {
					results[i] = true;
				} else if (((String)list.get(i)).equalsIgnoreCase("off") || ((String)list.get(i)).equalsIgnoreCase("n")
						|| ((String)list.get(i)).equalsIgnoreCase("no") || ((String)list.get(i)).equalsIgnoreCase("0")
						|| ((String)list.get(i)).equalsIgnoreCase("false")) {
					results[i] = false;
				} else {
					throw new ConversionException();
				}
			}
			return (results);
		} catch (Exception e) {
			throw new ConversionException(value.toString(), e);
		}
	}
}