/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.bean;

import java.util.List;
import java.util.Locale;

/**
 * TODO documentation
 * 
 * @author rlogiacco@users.sourceforge.net
 */
public class FloatArrayConverter extends ArrayConverter {

	private static final float[] model = new float[0];

	/**
	 * @see net.smartlab.web.bean.Converter#convert(java.lang.Class,
	 *      java.lang.Object, java.util.Locale)
	 */
	public Object convert(Class type, Object value, Locale locale) throws ConversionException {
		// Deal with the no-conversion-needed case
		if (model.getClass() == value.getClass()) {
			return (value);
		}

		// Deal with input value as a String array
		if (ArrayConverter.model.getClass() == value.getClass()) {
			try {
				String values[] = (String[])value;
				float[] results = new float[values.length];
				for (int i = 0; i < values.length; i++) {
					results[i] = Float.parseFloat(values[i]);
				}
				return (results);
			} catch (Exception e) {
				throw new ConversionException(value.toString(), e);
			}
		}

		// Parse the input value as a String into elements
		// and convert to the appropriate type
		try {
			List list = parseElements(value.toString());
			float[] results = new float[list.size()];
			for (int i = 0; i < results.length; i++) {
				results[i] = Float.parseFloat((String)list.get(i));
			}
			return (results);
		} catch (Exception e) {
			throw new ConversionException(value.toString(), e);
		}
	}
}