/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.bean;

import java.util.Locale;

import net.smartlab.web.StringEnumeration;

/**
 * TODO documentation
 * @author rlogiacco@users.sourceforge.net
 */
public class StringEnumerationConverter extends Converter {

	private final static String NAME = "decode";

	private final static Class[] ARGUMENTS = new Class[] {String.class};

	/**
	 * @see net.smartlab.web.bean.Converter#convert(java.lang.Class,
	 *      java.lang.Object, java.util.Locale)
	 */
	public Object convert(Class type, Object value, Locale locale) throws ConversionException {
		try {
			if (StringEnumeration.class.isAssignableFrom(type)) {
				return type.getMethod(NAME, ARGUMENTS).invoke(type.newInstance(), new Object[] {value});
			} else {
				return ((StringEnumeration)value).getCode();
			}
		} catch (Exception e) {
			throw new ConversionException("Invalid string enumeration " + value.toString(), e);
		}
	}

}