/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.page;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.TagSupport;

/**
 * Outputs the HTML code to make the tag body linked to the enclising tag. For
 * example, if the tag is enclosed by <code>PrevTag</code> the produced HTML
 * code results in a link to the previous page.
 * 
 * @author rlogiacco@users.sourceforge.net
 * @jsp.tag name="link" description="links the tag body to the enclosing tag"
 *          body-content="JSP"
 */
public class LinkTag extends org.apache.struts.taglib.html.LinkTag {

	/*# net.smartlab.web.paging.LinkableTag container */
	/*# net.smartlab.web.page.PageTag page */

	private static final long serialVersionUID = -4444110022479820664L;

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException {
		PaginateTag wrapper = (PaginateTag)TagSupport.findAncestorWithClass(this, PaginateTag.class);
		if (wrapper.isForm()) {
			super.setHref("javascript:paginate(" + ((LinkableTag)TagSupport.findAncestorWithClass(this, LinkableTag.class)).getPage() + ")");
		} else {
			super.setAction(wrapper.getHref() + ((LinkableTag)TagSupport.findAncestorWithClass(this, LinkableTag.class)).getPage());
		}
		return super.doStartTag();
	}
}