/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.page;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.tagext.IterationTag;

/**
 * TODO documentation
 * 
 * @author rlogiacco@users.sourceforge.net
 * @jsp.tag name = "pages"
 */
public class PageListTag extends AbstractTag implements IterationTag, LinkableTag {

	/**
	 * TODO documentation
	 */
	protected int index;

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException {
		if (super.getPaginator().getPageCount() > 1) {
			this.index = 0;
			return EVAL_BODY_INCLUDE;
		}
		return SKIP_BODY;
	}

	/**
	 * @see javax.servlet.jsp.tagext.IterationTag#doAfterBody()
	 */
	public int doAfterBody() throws JspException {
		if (++index < super.getPaginator().getPages().length) {
			return EVAL_BODY_AGAIN;
		}
		return SKIP_BODY;
	}

	/**
	 * @see net.smartlab.web.page.LinkableTag#getPage()
	 */
	public int getPage() {
		return super.getPaginator().getPages()[index];
	}

}