/*
 * The SmartWeb Framework
 * Copyright (C) 2004-2006
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * For further informations on the SmartWeb Framework please visit
 *
 *                        http://smartweb.sourceforge.net
 */
 
package net.smartlab.web.page;

import java.io.IOException;

import javax.servlet.jsp.JspException;

/**
 * Outputs the starting element index.
 * 
 * @author rlogiacco@users.sourceforge.net
 * @jsp.tag name="start" description="outputs the starting element index"
 *          body-content="empty"
 */
public class StartIndexTag extends AbstractTag {

	/**
	 * @see javax.servlet.jsp.tagext.Tag#doStartTag()
	 */
	public int doStartTag() throws JspException {
		try {
			context.getOut().write(Integer.toString(super.getPaginator().getStart()));
		} catch (IOException ioe) {
			throw new JspException(ioe);
		}
		return SKIP_BODY;
	}
}